package io.tswf.minecraft.blockventure.core.api.world.storage

import groovy.transform.CompileStatic

import java.lang.reflect.Type

@CompileStatic
interface IWorldCustomDataStorage {
    String getName()
    void commit()

    def <T> T readValue(String name, Class<T> classOfT)
    default <T> T readValue(String name, Type typeOfT) { (T) readValue(name, typeOfT.extractClass()) }

    default void writeValue(String name, Object value) { writeValue(name, value, value?.class) }
    void writeValue(String name, Object value, Type typeOfValue)
}