package io.tswf.minecraft.blockventure.core.api.world.storage

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.transmutation.expansion.IServerWorldCustomDataStorageAccess
import io.tswf.minecraft.blockventure.core.world.storage.NBTServerWorldCustomDataStorageIO
import net.minecraft.server.world.ServerWorld

@CompileStatic
class WorldStorages {

    static IWorldCustomDataStorage newNbtStorage(ServerWorld serverWorld, String name) {
        def storagesAccess = (IServerWorldCustomDataStorageAccess) serverWorld
        return storagesAccess.blockventureCustomStorages.computeIfAbsent(name) {
            NBTServerWorldCustomDataStorageIO.newStorage(serverWorld, name, true)
        }
    }

}
