package io.tswf.minecraft.blockventure.core.exception

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.world.storage.IWorldCustomDataStorage
import net.minecraft.server.world.ServerWorld

@CompileStatic
class ServerWorldCustomStorageSaveException extends RuntimeException implements ServerWorldCustomStoragesSaveException.Bypass {

    ServerWorld world
    IWorldCustomDataStorage storage

    ServerWorldCustomStorageSaveException(Throwable cause, ServerWorld world, IWorldCustomDataStorage storage) {
        super("Exception occurred while trying to save custom storage ${storage} for world ${world}: ", cause)
        this.world = world
        this.storage = storage
    }
}
