package io.tswf.minecraft.blockventure.core.inventory.screenhandler

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.transforms.nullsafe.NullSafe
import io.tswf.minecraft.blockventure.core.transmutation.view.ViewScreenHandler
import net.minecraft.entity.player.PlayerEntity
import net.minecraft.item.ItemStack
import net.minecraft.screen.ScreenHandler

@CompileStatic
class ScreenHandlerStackQuickMoveHelper {
    
    int[] slotsToTransferIndexes
    ScreenHandler screenHandler

    ScreenHandlerStackQuickMoveHelper(
            @NullSafe
            ScreenHandler screenHandler,

            @NullSafe
            int... slotsToTransferIndexes
    ) {
        this.slotsToTransferIndexes = slotsToTransferIndexes
        this.screenHandler = screenHandler
    }
    
    ItemStack quickMoveStack(@NullSafe PlayerEntity player, int slotIndex) {
        def viewScreenHandler = (ViewScreenHandler) screenHandler
        def newStackInFromTransferSlot = ItemStack.EMPTY
        def slotFromTransfer = screenHandler.slots.get(slotIndex)

        if (slotFromTransfer != null && slotFromTransfer.hasStack()) {
            def stackInFromTransferSlot = slotFromTransfer.stack
            newStackInFromTransferSlot = stackInFromTransferSlot.copy()

            for (def slotToTransferIndex : slotsToTransferIndexes) {
                def isStackTransferredFully = viewScreenHandler.callInsertItem(stackInFromTransferSlot, slotToTransferIndex, slotToTransferIndex, false)

                if (isStackTransferredFully) {
                    break
                }
            }

            if (stackInFromTransferSlot.isEmpty()) {
                slotFromTransfer.stack = ItemStack.EMPTY
            } else {
                slotFromTransfer.markDirty()
            }

            slotFromTransfer.onTakeItem(player, stackInFromTransferSlot)

            if (stackInFromTransferSlot.count == newStackInFromTransferSlot.count) {
                return ItemStack.EMPTY
            }
        }

        return newStackInFromTransferSlot
    }
}
